// THIS CODE IS PROVIDE FREE BY ZION, AND COMES WITHOUT ANY WARRANTY.

#import "aDataDelegate.h"
#import "NextTerm.h"
#import "../TermInterfaceProtocol.h"
#import "../TerminalEmulatorProtocol.h"

@implementation aDataDelegate


// dataHandler: This function called transparently by the
// NXApp object when data is available to read on fd.
// It will read in the awaiting data, and forward it to the terminal emulator.
void dataHandler(int fd, void *data)
{
	unsigned char buff[BUFF_SIZE];
	int numRead;
	id dataDelegate = data;

	numRead = [[dataDelegate pseudoterm] read:buff maxLen:BUFF_SIZE];
	[[dataDelegate ansiobj] appendBuff:buff len:numRead];
	return;
}

// get instance variable objects
- ansiobj {	return ansiObj; }
- pseudoterm { return pseudoTerm; }

// after loading nib with ScreenView object embedded...
- awakeFromNib
{
	if(screenViewObj) {

		// get our emulator object.
		ansiObj = [screenViewObj termEmulator];

		// create tty object.
		if(pseudoTerm = [NextTerm newPort])
			// setup the function to be called if data is ready on the tty
			DPSAddFD([pseudoTerm portFd], dataHandler, self, NX_BASETHRESHOLD);
		
		// make sure we get keyDown:'s without a mouse click.
		[theWindow makeKeyAndOrderFront:self];
		[theWindow makeFirstResponder:screenViewObj];
	}
	else {
		printf("ScreenViewObj not initialized!\n");
		exit(1);
	}

	return self;
}

- appWillTerminate:sender
{
	[pseudoTerm flushQueues];				// flush i/o queues.
	DPSRemoveFD( [pseudoTerm portFd] );		// remove watched FD
	pseudoTerm = [pseudoTerm free];			// close and free port.
//	[theWindow flushWindow];
//	[screenViewObj free];					// we shouldn't need to do this??
//	[theWindow close];						// we shouldn't need to do this...
											// how to stop the IPCFlushOutput console errors?

	return self;
}

// This method must be present for all dataDelegate's.
// This method is called for outgoing data...
- sendText:(unsigned char*)buff
{
	// forward the data to a receiving object...in this case a tty object.
	[pseudoTerm writeToPort:buff];
	return self;
}


// These methods demonstrate the find panel capabilities inherant to Zion's ScreenView.
- jumpToSelection:sender
{
	return [screenViewObj jumpToSelection:sender];
}

- findText:sender
{

	if([screenViewObj findText:[findTextField stringValue]
					ignoreCase:[findCaseButton state]
					 backwards:(![sender selectedCol])
						  wrap:YES])
		[screenViewObj jumpToSelection:sender];
	else
		NXBeep();
	return self;
}


@end
