// TerminalEmulator formal protocol
// terminal emulator objects which are dynamically
// loaded must conform to this protocol
// see TerminalEmulatorProtocol.rtf for protocol documentation.

#import <dpsclient/event.h>		// NXEvent type

@protocol TerminalEmulator

// This method is called by dataDelegate, and passes input from the active
// connection to the object which conforms to this protocol.
// This input can be processed as the terminal emulator designer wishes...
// from none...to some sort of graphical display.
// input should be send to ScreenView if the input is to be displayed
// in terminal window.
// see TermInterface.h
// length is needed since null (0) bytes could be sent and we don't
// want to mistake the null byte as the end of the buffer.
- appendBuff:(unsigned char*)input len:(int)buflen;

// sender is ScreenView object (displays terminal data).
- initWithCntrl:sender;

// Forwarded to emulator object from ScreenView object.
// We may alter the event if necessary before forwarding it to our dataDelegate
// using sendText:(unsigned char*)buff
- keyDown:(NXEvent *)keyEvent;

@end